
typedef struct ADC_t {
	int		first_time;	/* Flag for first access	*/
	int		fifo;		/* Address of Data FIFO port	*/
	int		clear;		/* Address of ADC clear port	*/
	int		start;		/* Address of Start Convert port*/
	int		dmaintclr;	/* Address of Interrupt clear 	*/
	int		counter_val;	/* Clock for counter		*/
	int		status;		/* Status of card		*/
	int		overrun;	/* Status of card		*/
	int		overflow;	/* Status of card		*/
	int		open;		/* Is device open?		*/
	int		scan;		/* Enable ADC input scanning	*/
	int		gain;		/* ADC input gain		*/
	int		polarity;	/* Bipolar or unipolar input	*/
	int		channel;	/* Input channel number		*/
	int		timebase;	/* Select clock souce for ADC	*/
	int		triggermode;	/* Select ADC trigger mode	*/
	int		dmaen;		/* Enable DMA transfers		*/
	int		inputmode;	/* Single ended/Diffl input	*/
	int		eckdrv;		/* Mode for EXTCONV line	*/
	int		eoircv;		/* Clock for interval scanning	*/
	int		intscan;	/* Enable interval scanning	*/
	int		waitfortrig;	/* Wait for software trigger	*/
	void		*frontbuf;	/* ADC data buffer		*/
	void		*backbuf;	/* ADC data buffer		*/
	int		bufsize;	/* Size of buffer		*/
	int		residue;	/* Number left to transfer	*/
	int		count;		/* Number of values to read	*/
	int		indx;		/* Data buffer index		*/
	int		incr;		/* Data buffer index		*/
	struct semaphore sem;		/* Semaphore to lock port access*/
	struct wait_queue *wait;
} ADC_t;

extern void adc_interrupt( ADC_t *adc, int status );
extern ADC_t *get_adc( int minor );
extern void free_adc( ADC_t *adc );
