
/* Counter status flags */
#define COUNTER_COUNTING	1
#define COUNTER_WAITFORINT	2


/* Counter A/B Mode Register bit definitions */
#define	BCD			0x01	/* 0 = Binary, 1 = BCD		*/
#define	M0			0x02	/* Counting mode		*/
#define	M1			0x04
#define	M2			0x08
#define	RL0			0x10	/* Read/Load operation		*/
#define	RL1			0x20
#define	SC0			0x40	/* Select Counter (0 - 3)	*/
#define	SC1			0x80


typedef struct Counter_t {
	int	first_time;		/* Flag for first use		*/
	int	data_port;		/* The I/O port address 	*/
	int	mode_port;		/* The I/O port address 	*/
	int	num;			/* Counter number		*/
	int	minor;			/* Device minor number		*/
	int	mode;			/* Mode for counter		*/
	int	bcd;			/* BCD or Binary?		*/
	int	status;			/* Status of counter		*/
	int	open;			/* Are we currently open	*/
} Counter_t;

int Write8253( Counter_t *counter, unsigned int data );

unsigned int Read8253( Counter_t *counter );

int SetMode8253( Counter_t *counter, int mode );

int SetCountStyle( Counter_t *counter, int bcd );

int Open8253( Counter_t *counter );

int Close8253( Counter_t *counter );

int Init8253( Counter_t *counter, int minor, int num, int data_port, int mode_port );

int SetHigh8253( Counter_t *counter );

int SetLow8253( Counter_t *counter );
