
typedef struct Dac_t {
	int		mode;		/* Mode of operation		*/
	int		datalo;		/* Address of 8 bit data port	*/
	int		datahi;		/* Address of 8 bit data port	*/
	struct semaphore sem;		/* Semaphore to lock port access*/
	struct wait_queue *wait;
	short		*buf;		/* Waveform data buffer		*/
	int		nbuf;		/* Size of waveform buffer	*/
	int		indx;		/* Waveform data buffer index	*/
	short		val;		/* Current value in DAC buffer	*/
	short		nextval;	/* Next value in DAC buffer	*/
	int		counter_val;	/* Count loaded onto counter	*/
	int		open;		/* Flag if DAC is open		*/
	int		interrupt_flag;	/* Flag interrupt handler	*/
	int		num;		/* DAC number			*/
	int		trace;		/* Current trace number		*/
	int		ntraces;	/* # of traces to output	*/
	int		stop;		/* Flag to stop DAC output	*/
	int		encoding;	/* Bipolar /Unipolar output	*/
	int		timebase;	/* Timebase for counter A2	*/
	int		first_time;	/* Flag for initialisation	*/
} Dac_t;

extern void dac_interrupt( Dac_t *dac, int numdacs );
