#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "labpc.h"

void Usage( void )
{
	fprintf( stderr, "Usage: diotest [-setbit n] [-resetbit n] [-write n] [-read] device_file_name\n" );
}

int main( int argc, char **argv )
{
	char		filename[200];
	int		fd;
	int		n;
	char		c;

	if (argc < 2) {
		Usage();
		exit( 1 );
	}

	strcpy( filename, argv[--argc] );
	argv[argc] = NULL;
	if ((fd = open( filename, O_RDWR )) < 0) {
		perror( filename );
		exit( 2 );
	}

	while (*++argv && **argv == '-') {
		if (!strcmp( *argv, "-setbit" )) {
			if (sscanf( *++argv, "%i", &n ) != 1) {
				fprintf( stderr, "Invalid number \"%s\"\n",
					 *argv );
				Usage();
				exit( 2 );
			}
			if (ioctl( fd, DIO_SETBIT, n ) < 0) {
				perror( filename );
				exit( 2 );
			}
		} else if (!strcmp( *argv, "-resetbit" )) {
			if (sscanf( *++argv, "%i", &n ) != 1) {
				fprintf( stderr, "Invalid number \"%s\"\n",
					 *argv );
				Usage();
				exit( 2 );
			}
			if (ioctl( fd, DIO_RESETBIT, n ) < 0) {
				perror( filename );
				exit( 2 );
			}
		} else if (!strcmp( *argv, "-write" )) {
			if (sscanf( *++argv, "%i", &n ) != 1) {
				fprintf( stderr, "Invalid number \"%s\"\n",
					 *argv );
				Usage();
				exit( 2 );
			}
			c = n;
			write( fd, &c, 1 );
		} else if (!strcmp( *argv, "-read" )) {
			if (read( fd, &c, 1 ) != 1) {
				perror( filename );
				exit( 2 );
			}
			n = c & 0xff;
			printf( "0x%x\n", n );
		} else {
			fprintf( stderr, "Unknown option: %s\n", *argv );
			Usage();
			exit( 2 );
		}
	}

	close( fd );

	return 0;
}

	
	
	
	
