#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "labpc.h"

void Usage( void )
{
	fprintf( stderr, "Usage: readcounter [-n num_values] filename\n" );
}

int main( int argc, char **argv )
{
	unsigned short	count;
	char	*filename;
	int	n = 1;
	int	fd;

	while (*++argv && **argv == '-') {
		if (!strcmp( *argv, "-n" )) {
			if (sscanf( *++argv, "%d", &n ) != 1) {
				fprintf( stderr, "Invalid number: %s\n", *argv );
				Usage();
				exit( 2 );
			}
		} else {
			fprintf( stderr, "Unknown option: %s\n", *argv );
			exit( 2 );
		}
	}

	if ((filename = *argv) == NULL) {
		Usage();
		exit( 1 );
	}
	
	/* Open the device file for the counter */
	if ((fd = open( filename, O_RDONLY )) < 0) {
		perror( filename );
		exit( 2 );
	}

	/* Read the values from the counter */
	while (n-- > 0) {
		if (read( fd, &count, sizeof( short ) ) < sizeof( short )) {
			perror( filename );
			exit( 2 );
		}
		printf( "%d\n", count );
	}

	close( fd );

	return 0;
}

	
	
	
	
